/* PhyloPattern
 * Copyright (C) 2005-2009 Philippe Gouret
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA. The text ol license can be also found 
 * at http://www.gnu.org/copyleft/gpl.html
 */

//------------------------------------------------------------------------------
// To show how to use PhyloPattern within a Java application
// Philippe Gouret
//------------------------------------------------------------------------------

/**
 *  Signal
 *  @since JDK1.2
 */
package gnu.prolog.test;

//imported library classes
import java.util.*;
import java.io.*;

//import project classes
import gnu.prolog.vm.*;
import gnu.prolog.term.*;
import gnu.prolog.io.*;
import gnu.prolog.database.PrologTextLoaderError;

/**
 *  To show how to use PhyloPattern within a Java application
 *  @author Philippe Gouret
 */
public class TestPhyloPatternWithJavaIntegration
{
	public static void main(String[] args)
	{
		// Prolog files to be loaded
		List<String> files = new Vector<String>();
		files.add("src/tools.pl");
		files.add("src/PhyloPattern.pl");
		files.add("src/samples.pl");
		
		// Prolog world
		CallerContext prologWorld = new CallerContext("", files);
		
		// call predicate associated with third sample, display all solutions to the orthology query
		int res = prologWorld.callPredicate("request1", "test_pattern_matching(Ortholog)"); 
		while(res != CallerContext.CALL_FAILED)
		{
			// one solution
			System.out.println("Ortholog = " + prologWorld.getResults("request1").firstElement() + "\n");
			
			// next
			res = prologWorld.callPredicate("request1", ""); 
		}
	}
}


